(defpackage :xmls-utilities
  (:use :common-lisp :xmls)
  (:export #:parse-xml-file
	   #:get-attribute))

(in-package :xmls-utilities)

(defun parse-xml-file (filename)
  "Parse a file, given a filename, using xmls"
  (with-open-file (file filename)
     (parse file)))

;; (defun get-attribute (attribute-list name)
;;   "Get the value of an attribute in an attribute alist with modified version of xmls"
;;   (let ((attribute (assoc name attribute-list :test #'string=)))
;;     (if attribute
;; 	(cdr attribute)
;;       (error "Attribute not found: ~S" name))))

(defun get-attribute (attribute-list name)
  "For some strange and perverse reason, xmls stores attributes in a structure that is almost but not entirely like an alist.
This function gets the value of an attribute in one of these pseudo-alists"
  (if attribute-list
      (let ((current-attribute (car attribute-list))
	    (other-attributes (cdr attribute-list)))
	(if (string= (car current-attribute)
		     name)
	    (second current-attribute)		; We've found it
	  (get-attribute other-attributes name)))
    (error "Attribute not found: ~S" name)))